Subject: Re: Column Filtering in Logical Replication

From: Alvaro Herrera <[email-masked]>
Date: Tue, 15 Feb 2022 21:33:32 -0300

On 2022-Feb-16, Tomas Vondra wrote:

> Here's an updated version of the patch, rebased to current master. Parts
> 0002 and 0003 include various improvements based on review by me and another
> one by Peter Smith [1].

Thanks for doing this!

> 1) partitioning with pubviaroot=true

I agree that preventing the inconsistencies from happening is probably
the best.

> 2) merging multiple column filters
> 
> When the table has multiple column filters (in different publications), we
> need to merge them. Which works, except that FOR ALL TABLES [IN SCHEMA]
> needs to be handled as "has no column filter" (and replicates everything).

Agreed.

> 3) partitioning with pubivaroot=false
> 
> When a partitioned table is added with (pubviaroot=false), it should not be
> subject to column filter on the parent relation, which is the same behavior
> used by the row filtering patch.

You mean each partition should define its own filter, or lack of filter?
That sounds reasonable.

-- 
Álvaro Herrera           39°49'30"S 73°17'W  —  https://www.EnterpriseDB.com/
"Pensar que el espectro que vemos es ilusorio no lo despoja de espanto,
sólo le suma el nuevo terror de la locura" (Perelandra, C.S. Lewis)